/* Cyclic Redundancy Check algorithm, complete with traditional error.
 * Copyright  2002, 2003, 2004 Ted Phelps
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms fo the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the `etagit' program; see the file `COPYING'.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place -
 * Suite 330, Boston, MA 02111-1307, USA. */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#ifdef HAVE_WINCONFIG_H
#include <winconfig.h>
#endif
#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

/* Print out the bytes of a stream */
void fhexdump(char *buffer, size_t length, FILE *out)
{
    char *point;
    int i, ch;

    /* Go through the buffer in 16-byte chunks */
    for (point = buffer - ((int)buffer & 0xf);
	 point < buffer + length;
	 point += 16)
    {
	fprintf(out, "%9p:", point);

	/* Print the 16 bytes as hex */
	for (i = 0; i < 16; i++)
	{
	    if (i % 8 == 0)
	    {
		fputc(' ', out);
	    }

	    if (buffer <= point + i && point + i < buffer + length)
	    {
		fprintf(out, "%02x ", (unsigned char)*(point + i));
	    }
	    else
	    {
		fprintf(out, "   ");
	    }
	}

	/* Print the 16 bytes as ASCII */
	fputc('>', out);
	for (i = 0; i < 16; i++)
	{
	    if (buffer <= point + i && point + i < buffer + length)
	    {
		ch = (unsigned char)*(point + i);
		if (ch < 32 || ch > 126)
		{
		    fputc('.', out);
		}
		else
		{
		    fputc(ch, out);
		}
	    }
	    else
	    {
		fputc(' ', out);
	    }
	}

	fprintf(out, "<\n");
    }
}
