/* Cyclic Redundancy Check algorithm, complete with traditional error.
 * Copyright  2002, 2003, 2004 Ted Phelps
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms fo the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the `etagit' program; see the file `COPYING'.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place -
 * Suite 330, Boston, MA 02111-1307, USA. */

#ifndef IDS_H
#define IDS_H 1

#define MAX_NAME_SIZE 63

struct rfid_tag
{
    /* The tag's unique numeric identifier */
    int64_t id;

    /* The tag's symbolic name */
    char name[MAX_NAME_SIZE + 1];
};

/* Reads the tag table from the input stream.  Returns a table of
 * tags, sorted by ascending id. */
int read_ids(FILE *stream, struct rfid_tag **tags_out, size_t *count_out);

/* Locates the name corresponding to the given id in the table */
char *find_id(struct rfid_tag *tags, size_t count, int64_t id);

#endif /* IDS_H */
